# Copyright 2004-2005 James Bunton <james@delx.cjb.net>
# Licensed for distribution under the GPL version 2, check COPYING for details

from twisted.python import log
import sys

class INFO : pass
class WARN : pass
class ERROR: pass

class LogEvent:
	def __init__(self, category=INFO, ident="", msg="", log=True):
		self.category, self.ident, self.msg = category, ident, msg
		frame = sys._getframe(1)
		self.klass = frame.f_locals.get("self", frame.f_code.co_filename)
		self.method = frame.f_code.co_name
		self.args = frame.f_locals
		if log:
			self.log()
	
	def __str__(self):
		args = {}
		for key in self.args.keys():
			val = self.args[key]
			args[key] = val
			try:
				if len(val) > 128:
					args[key] = "Oversize arg"
			except:
				# If its not an object with length, assume that it can't be too big. Hope that's a good assumption.
				pass
		category = str(self.category).split(".")[1]
		return "%s :: %s :: %s :: %s :: %s :: %s" % (category, str(self.ident), self.msg, self.method, str(self.klass), str(args))
	
	def log(self):
		log.msg(self)

